﻿#pragma once
// класс для открытия файла и использование полосы прокрутки, кнопок выбора файлов, кнопки сравнения файла, а также поля для отображения сходства и различий в файлах
class CFileOpen : public Window
{
private:
	int m_id;
public:
	// определение ползунка, выбора файла, кнопки выбора, размера файла
	CScrollBar* m_scrollbar = new CScrollBar;
	CEdit* m_fileName = new CEdit;
	CButton* m_btnChoose = new CButton;
	TCHAR m_szFileName[MAX_PATH];
	// открытие файла, установление ползунка и определение пути файла
	CFileOpen() {
		m_scrollbar->setRange(0, 0);
		m_szFileName[MAX_PATH] = { 0 };
	}

	void setId(int id) {
		m_id = id;
	}
	// координаты кнопок выбора файлов для сравнения, ползунка
	void sizeBlock(int w, int h) {
		m_btnChoose->Size
		(
			BTN_CHOOSE_X(m_id, w),
			BTN_CHOOSE_Y,
			BTN_CHOOSE_W,
			BTN_CHOOSE_H
		);

		m_fileName->Size
		(
			EDIT_FILENAME_X(m_id, w),
			EDIT_FILENAME_Y,
			EDIT_FILENAME_W(w),
			EDIT_FILENAME_H
		);

		m_scrollbar->Size
		(
			SCROLL_X(m_id, w),
			SCROLL_Y,
			SCROLL_W,
			SCROLL_H(h)
		);
	}
	// координаты кнопок выбора файлов для сравнения, ползунка
	bool createBlock(HWND parent) {
		m_btnChoose->Create
		(
			L">>",
			BTN_CHOOSE_X(m_id, m_Width),
			BTN_CHOOSE_Y,
			BTN_CHOOSE_W,
			BTN_CHOOSE_H,
			parent
		);

		if (m_btnChoose->m_hWnd == NULL)
		{
			return false;
		}

		m_fileName->Create
		(
			EDIT_FILENAME_X(m_id, m_Width),
			EDIT_FILENAME_Y,
			EDIT_FILENAME_W(m_Width),
			EDIT_FILENAME_H,
			parent
		);


		if (m_fileName == NULL)
		{
			return false;
		}

		m_scrollbar->Create
		(
			SCROLL_X(m_id, m_Width),
			SCROLL_Y,
			SCROLL_W,
			SCROLL_H(m_Height),
			parent
		);

		if (m_scrollbar == NULL)
		{
			return false;
		}

		return true;
	}
	// путь, который изначально открывается при открытии диалогового окна по выбору папки или файла
	void getFilePath() {
		GetWindowText
		(
			m_fileName->m_hWnd,
			m_szFileName,
			sizeof(m_szFileName)
		);
	}
};


