﻿#pragma once
// класс для полосы прокрутки (ползунка)
class CScrollBar : public Window
{
private:
	DOUBLE  m_nScrollMax64 = 0;
	DOUBLE  m_coef = 1;
	DOUBLE  m_nScrollPos64 = 0;
public:

	BOOL Create( // создание
		int X, // присвоение координат
		int Y,
		int nWidth,
		int nHeight,
		HWND hWndParent
	) {
		m_hWnd = CreateWindowEx // создание перекрывающего окна
		(
			NULL,
			L"SCROLLBAR",
			NULL,
			WS_VISIBLE | WS_CHILD | SBS_VERT | WS_CLIPCHILDREN,
			X,
			Y,
			nWidth,
			nHeight,
			hWndParent,
			nullptr,
			NULL,
			NULL
		);

		m_Width = nWidth; // ширина
		m_Height = nHeight; // высота

		if (!m_hWnd)
			return false;

		return true;
	}

	// начало и конец диапазона значений
	void setRange(int nMinPos, long long nMaxPos) {
		if (nMaxPos > 65535)
		{
			m_coef = (double)nMaxPos / 65535;
			m_nScrollMax64 = 65535;
		}
		else {
			m_coef = 1.0;
			m_nScrollMax64 = nMaxPos;
		}

		SetScrollRange(this->m_hWnd, SB_CTL, nMinPos, nMaxPos, TRUE);
	}
	// установление позиций
	void setPose() {
		if (m_nScrollPos64 > m_nScrollMax64) {
			m_nScrollPos64 = m_nScrollMax64;
		}

		if (m_nScrollPos64 < 0) {
			m_nScrollPos64 = 0;
		}

		SetScrollPos(this->m_hWnd, SB_CTL, m_nScrollPos64, TRUE);
	}
	// получение позиций
	DOUBLE getPose() {
		return m_nScrollPos64 * m_coef;
	}
	// прокрутка вверх в размере одной страницы (клавишей "Page Up")
	void pageUp(int Height) {
		m_nScrollPos64 -= (MAX_COUNT_OF_LINES(Height) - 3) / m_coef;
	}
	// прокрутка вниз в размере одной страницы (клавишей "Page Down")
	void pageDown(int Height) {
		m_nScrollPos64 += (MAX_COUNT_OF_LINES(Height) - 3) / m_coef;
	}
	// прокрутка вверх 
	void lineUp() {
		m_nScrollPos64 -= 1 / m_coef;
	}
	// прокрутка вниз 
	void lineDown() {
		m_nScrollPos64 += 1 / m_coef;
	}
	// прокрутка с помощью мыши
	void mouseDrag(long long pose) {
		m_nScrollPos64 = pose;
	}
	// прокрутка на самое начало
	void top() {
		m_nScrollPos64 = 0;
	}
	// прокрутка на самый конец
	void bottom() {
		m_nScrollPos64 = m_nScrollMax64;
	}
};
