﻿// прорисовка текста и Hex-адресов с Hex-байтов
#pragma once
#include "Colours.h"
class CTextPainter
{
public:
	VOID FindBlock(fileStruct arrayOfFiles[], DWORD dwAllocationGranularity); // нахождение блока
	VOID drawLines(fileStruct fileFieldArray[], HDC& hdc, DOUBLE  nxPos, int& countOfLines, int Width, int Height); // прорисовка линий
	BOOL m_toDraw; // прорисовка или нет
	bool PrepareBufferToPaint(fileStruct array[], int length); // приготовление буфера к прорисовке

private:
	VOID num2hex(long long n, char* r, int maxLenght); //перевод из чисел в Hex-значения
	CHAR* char2hex(char c, char* buf, bool toDraw); //перевод из набора символов в Hex-значения
	VOID drawText(int amout, HDC hdc, CHAR ch, int x, int y); // прорисовка текста
	VOID whatColor(char* arrayOfH[], HDC& hdc); // определение цвета: красный или чёрный
	int GetMaxFileIndex(fileStruct array[], int length); //получение максимального индекса файла
	int GetMaxLength(fileStruct array[], int maxIndex); //получение максимального значения файла
	//координаты
	int m_x = 0, m_y = 0;
	DWORD64 m_prev = 0;

	int maxIndex = 0;
	DWORD64 sumOfBytes = 0;
	int maxLength = 0;
};
//получение максимального индекса файла
int CTextPainter::GetMaxFileIndex(fileStruct array[], int length) {
	DWORD64 max = 0;
	int tempMaxIndex = 0;

	for (int i = 0; i < length; i++) {
		if (array[i].fileInfo.m_qwFileSize > max) {
			max = array[i].fileInfo.m_qwFileSize;
			tempMaxIndex = i;
		}
	}
	return tempMaxIndex;
}//получение максимального значения файла
int CTextPainter::GetMaxLength(fileStruct array[], int maxIndex) {
	int tempMaxLength = 0;
	DWORD64 tempFileSize = array[maxIndex].fileInfo.m_qwFileSize;

	while (tempFileSize > 0) {
		tempFileSize /= 16;
		tempMaxLength++;
	}
	return tempMaxLength;
}
// приготовление буфера к прорисовке
bool CTextPainter::PrepareBufferToPaint(fileStruct array[], int length)
{
	for (int i = 0; i < length; i++) {
		array[i].fileInfo.m_hFile = CreateFile
		(
			array[i].fileOpen.m_szFileName,
			GENERIC_READ,
			FILE_SHARE_READ,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			NULL
		);

		if (array[i].fileInfo.m_hFile == INVALID_HANDLE_VALUE)
		{
			showError(array[i].fileOpen.m_szFileName);
			return false;
		}
	}

	for (int i = 0; i < length; i++) {
		array[i].fileInfo.m_hMapping = CreateFileMapping
		(
			array[i].fileInfo.m_hFile,
			NULL,
			PAGE_READONLY,
			0,
			0,
			NULL
		);

		if (array[i].fileInfo.m_hMapping == NULL)
		{
			showError(array[i].fileOpen.m_szFileName);
			return false;
		}
	}

	for (int i = 0; i < length; i++) {
		array[i].fileInfo.m_qwFileSize = GetFileSize(array[i].fileInfo.m_hFile, &array[i].fileInfo.m_dwFileSizeHigh);
		array[i].fileInfo.m_qwFileSize += (((DWORD64)array[i].fileInfo.m_dwFileSizeHigh) << 32);
	}

	maxIndex = GetMaxFileIndex(array, NUM_OF_FILES);
	maxLength = GetMaxLength(array, maxIndex);

	return true;
}
// нахождение блока
VOID CTextPainter::FindBlock(fileStruct arrayOfFiles[], DWORD dwAllocationGranularity) {
	DWORD64 qwFileOffset;

	DWORD64 qwStartPosition = +arrayOfFiles[0].fileOpen.m_scrollbar->getPose() * LINE;
	qwFileOffset = qwStartPosition;
	qwFileOffset = qwFileOffset - (qwFileOffset % dwAllocationGranularity);

	for (int i = 0; i < NUM_OF_FILES; i++) {
		arrayOfFiles[i].fileInfo.m_dwBytesInBlock = dwAllocationGranularity;
		if (arrayOfFiles[i].fileInfo.m_qwFileSize - qwStartPosition < dwAllocationGranularity)
		{
			arrayOfFiles[i].fileInfo.m_dwBytesInBlock = (DWORD)arrayOfFiles[i].fileInfo.m_qwFileSize - qwFileOffset;
		}
	}

	for (int i = 0; i < NUM_OF_FILES; i++) {
		arrayOfFiles[i].fileInfo.m_dataPtr = (PBYTE)MapViewOfFile
		(
			arrayOfFiles[i].fileInfo.m_hMapping,
			FILE_MAP_READ,
			(DWORD)(qwFileOffset >> 32),
			(DWORD)(qwFileOffset & 0xFFFFFFFF),
			arrayOfFiles[i].fileInfo.m_dwBytesInBlock
		);

	}

	m_prev = qwFileOffset;

	/*InvalidateRect(m_hWnd, NULL, TRUE);*/
}

VOID CTextPainter::drawLines(fileStruct fileFieldArray[], HDC& hdc, DOUBLE  nxPos, int& countOfLines, int Width, int Height) {
	//буфер, содержащий номер строки в Hex - представлении
	char bufferNum[MAX_BUFFER_SIZE] = { };
	//массив буферов, которые хранят i-е символы файлов
	char* arrayOfH[NUM_OF_FILES];

	//if (nxPos > 8) nxPos = nxPos + 8 - ((int)nxPos % 8);

	for (int i = 0; i < NUM_OF_FILES; i++) {
		arrayOfH[i] = fileFieldArray[i].fileInfo.m_bufferHex;
	}
	//обрабатывает каждый байт блока выделенной памяти 
	//проверяет, чтобы количество отрисованных линий было меньше, чем их может быть отрисовано
	for (DWORD64 dwByte = nxPos - m_prev; dwByte < (fileFieldArray[maxIndex].fileInfo.m_dwBytesInBlock) && countOfLines <= MAX_COUNT_OF_LINES(Height); dwByte++)
	{

		SetTextColor(hdc, COLOR_BLACK);
		//каждые 8 байтов начинается отрисовка новой строки
		if (dwByte % 8 == 0) {
			num2hex(dwByte + m_prev, bufferNum, maxLength);
			m_y = DEFAULT_LINE_Y + countOfLines * FONT_HEIGHT;
			countOfLines++;
			for (int i = 0; i < NUM_OF_FILES; i++) {
				//отрисовывает Hex-представление номера строки
				TextOutA(hdc, (Width / NUM_OF_FILES) * i, m_y, bufferNum, strlen(bufferNum));
				//отрисовывает символ '|'
				TextOut(hdc, (Width / NUM_OF_FILES) * (i + 1) - 150, m_y, L"|", 1);
			}
			m_x = DEFAULT_LINE_HEX_X;
		}
		//временный буфер для хранения символа, который должен быть отрисован
		CHAR tempChar[NUM_OF_FILES];
		for (int i = 0; i < NUM_OF_FILES; i++) {
			//если один из файлов или блоков байтов закончился, сохраняем символ ' ' для его последущей отрисовки
			if (fileFieldArray[i].fileInfo.m_dataPtr == NULL || dwByte >= fileFieldArray[i].fileInfo.m_dwBytesInBlock) {
				arrayOfH[i] = char2hex(' ', arrayOfH[i], false);
				tempChar[i] = ' ';
			}
			//иначе сохраняем dwByte-ый символ для его последующей отрисовки 
			else {
				arrayOfH[i] = char2hex(fileFieldArray[i].fileInfo.m_dataPtr[dwByte], arrayOfH[i], true);
				tempChar[i] = (CHAR)fileFieldArray[i].fileInfo.m_dataPtr[dwByte];
			}
		}
		whatColor(arrayOfH, hdc);
		for (int i = 0; i < NUM_OF_FILES; i++) {
			drawText((Width / NUM_OF_FILES) * (i + 1) - 150, hdc, tempChar[i], m_x, m_y);
			//отрисовывает сохранённый ранее Hex-код dwByte-ого символа
			TextOutA(hdc, m_x + (Width / NUM_OF_FILES) * i, m_y, arrayOfH[i], strlen(arrayOfH[i]));
		}
		m_x += X_SHIFT;
	}
}


/*
 * Функция преобразует число в его Hex-представление
 *
 * n - число, которое нужно преобразовать
 * r - буфер, который хранит Hex-представление числа
 */
VOID CTextPainter::num2hex(long long n, char* r, int maxLenght)
{
	int p, h;
	for (int i = 0; i <= maxLenght; i++)
	{
		r[i] = 0;
	}
	p = maxLenght - 1;
	for (int i = 1; i <= maxLenght; i++)
	{
		h = n % 16;
		r[p--] = HEX_DIGITS[h];
		n /= 16;
	}
	r[maxLenght] = ':';
}

/*
 * Функция преобразует символ в его Hex - представление
 *
 * c - символ, который нужно преобразовать
 * buf - буфер, в который сохраняется Hex - представление символа
 * toDraw - нужно ли рисовать Hex - представление символа или нет,
 * чтобы не выводилось 00, когда файл закончился
 */
CHAR* CTextPainter::char2hex(char c, char* buf, bool toDraw)
{
	int h, l;
	h = (c >> 4) & 0xF;
	l = (c >> 0) & 0xF;
	if (!toDraw) {
		buf[0] = ' ';
		buf[1] = ' ';
		buf[3] = ' ';
	}
	else {
		buf[0] = HEX_DIGITS[h];
		buf[1] = HEX_DIGITS[l];
		buf[3] = ' ';
	}
	return buf;
}

/*
 * Функция отрисовывет символы
 *
 * amout - сдвиг по координате x, на который нужно сместиться для корректной отрисовки символов
 * hdc - описатель окна
 * ch - символ, который нужно нарисовать
 * x - координата x для отрисовки символа
 * y - координата y для отрисовки символа
 */
VOID CTextPainter::drawText(int amout, HDC hdc, CHAR ch, int x, int y) {
	//если данный символ возможно отрисовать, то рисуем его
	//if (isprint(ch)) {
		TextOutA(hdc, amout - 20 + x / 2, y, &ch, 1);
	//}
	////иначе рисуем символ '.' вместо него
	//else {
	//	TextOut(hdc, amout - 20 + x / 2, y, L".", 1);
	//}
}

/*
 * Функция определяет, в какой цвет нужно перекрасить текст.
 * Если хотя бы один из символов отличается от других, то текст красится в красный, иначе
 * текст красится в чёрный
 *
 * arrayOfH - массив Hex-кодов символов
 * hdc - описатель окна
 */
VOID CTextPainter::whatColor(char* arrayOfH[], HDC& hdc) {
	BOOL areDiffers = false;

	char prev = arrayOfH[0][0];
	char prev2 = arrayOfH[0][1];

	//поиск отличающихся символов
	for (int i = 1; i < NUM_OF_FILES; i++) {
		if (prev != arrayOfH[i][0] || prev2 != arrayOfH[i][1]) {
			areDiffers = true;
			break;
		}
		prev = arrayOfH[i][0];
		prev2 = arrayOfH[i][1];
	}
	// установление цвета: чёрный - если отличий нет; красный - если присутствуют отличия
	if (areDiffers) {
		SetTextColor(hdc, COLOR_RED);
	}
	else {
		SetTextColor(hdc, COLOR_BLACK);
	}

}